/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	---------------------------------------------------------------------------
	GEZ(GEnesys Zipped sound log file) to GYM filter
	gez.c
*/

#include "in_gez.h"

#if USE_ZLIB

#include <windows.h>
#include "../ZLIB/unzip.h"
#include <stdio.h>

static BOOL CheckExt(LPSTR filename, LPSTR ext)
{
	LPSTR p, p2 = NULL, prev = NULL;
	for (p = filename; p != prev; p = CharNext(prev = p))
	{
		if (*p == '/' || *p == '\\' || *p == ':') p2 = NULL;
		if (*p == '.') p2 = p + 1;
	}
	if (p2 == NULL) return FALSE;
	return (lstrcmpi(p2, ext) == 0);
}

void *GEZ_extract(LPCSTR lpszSrcFile, int *psize, int *ploop, char *title)
{
	CHAR filename[MAX_PATH];
	unzFile unzfp = NULL;
	void *buf = NULL;
	void *ret = NULL;

	*ploop = 0;
	*title = '\0';

	/* try */
	do {
		unzfp = unzOpen(lpszSrcFile);
		if (unzfp == NULL) break;
		unzGoToFirstFile(unzfp);
		do {
			uLong len;
			unz_file_info finfo;
			unzGetCurrentFileInfo(unzfp, &finfo, filename, MAX_PATH, NULL, 0, NULL, 0);
			if (!CheckExt(filename, "GYM"))
			{
				if (unzGoToNextFile(unzfp) == UNZ_OK)
					continue;
				else
					break;
			}
			if (UNZ_OK != unzOpenCurrentFile(unzfp)) break;
			buf = malloc(finfo.uncompressed_size + 8);
			if (buf == NULL) break;
			len = unzReadCurrentFile(unzfp, buf ,finfo.uncompressed_size);
			unzCloseCurrentFile(unzfp);
			if (len != finfo.uncompressed_size) break;
			ret = buf;
			buf = NULL;
			if (psize) *psize = finfo.uncompressed_size;
			unzGoToFirstFile(unzfp);
			do {
				char tmp[256+16];
				uLong i;
				unzGetCurrentFileInfo(unzfp, NULL, filename, MAX_PATH, NULL, 0, NULL, 0);
				if (!CheckExt(filename, "GYI"))
				{
					if (unzGoToNextFile(unzfp) == UNZ_OK)
						continue;
					else
						break;
				}
				if (UNZ_OK != unzOpenCurrentFile(unzfp)) break;
				len = unzReadCurrentFile(unzfp, tmp ,sizeof(tmp));
				unzCloseCurrentFile(unzfp);
				/* 1s:^Cg */
				for (i = 0; i < len && tmp[i]; i++)
				{
					if (tmp[i] == '\xd') break;
					if (tmp[i] == '\xa') break;
					title[i] = tmp[i];
				}
				title[i] = '\0';
				if (i < len && tmp[i] == '\xd') i++;
				if (i < len && tmp[i] == '\xa') i++;
				/* 2s:[v|Cg */
				while (i < len && '0' <= tmp[i] && tmp[i] <= '9')
					*ploop = *ploop * 10 + tmp[i++] - '0';
				/* ȍ~R */
				break;
			} while (1);
			break;
		} while (1);
		break;
	} while(0);
	/* finaly */
	if (unzfp != NULL) unzClose(unzfp);
	if (buf != NULL) free(buf);
	return ret;
}
#endif

static void GetPathNoExt(char *des, char *src)
{
	char *p = NULL;
	while (*src != '\0')
	{
		if (IsDBCSLeadByte(*src))
		{
			*(des++) = *(src++);
			*(des++) = *(src++);
			continue;
		}
		switch (*src)
		{
			case ':': case '\\': case '/':
				p = NULL;
				break;
			case '.':
				p = des;
				break;
		}
		*(des++) = *(src++);
	}
	if (p != NULL)
		*p = '\0';
	else
		*des = '\0';
}



void GYI_load(char *lpszSrcFile, int *ploop, char *title)
{
	FILE *fp;
	int i, len;
	char tmp[256+16], searchPath[MAX_PATH];
	GetPathNoExt(searchPath, lpszSrcFile);
	lstrcat(searchPath, ".GYI");
	fp = fopen(searchPath, "rb");
	if (fp == NULL) return;
	len = fread(tmp, 1, sizeof(tmp), fp);
	fclose(fp);
	/* 1s:^Cg */
	for (i = 0; i < len && tmp[i]; i++)
	{
		if (tmp[i] == '\xd') break;
		if (tmp[i] == '\xa') break;
		title[i] = tmp[i];
	}
	title[i] = '\0';
	if (i < len && tmp[i] == '\xd') i++;
	if (i < len && tmp[i] == '\xa') i++;
	/* 2s:[v|Cg */
	while (i < len && '0' <= tmp[i] && tmp[i] <= '9')
		*ploop = *ploop * 10 + tmp[i++] - '0';
	/* ȍ~R */
}
